##############################################################################
# Institute for the Design of Advanced Energy Systems Process Systems
# Engineering Framework (IDAES PSE Framework) Copyright (c) 2018, by the
# software owners: The Regents of the University of California, through
# Lawrence Berkeley National Laboratory,  National Technology & Engineering
# Solutions of Sandia, LLC, Carnegie Mellon University, West Virginia
# University Research Corporation, et al. All rights reserved.
# 
# Please see the files COPYRIGHT.txt and LICENSE.txt for full copyright and
# license information, respectively. Both files are also available online
# at the URL "https://github.com/IDAES/idaes".
##############################################################################
"""
Set the alamo and gams paths here.
"""
import collections as col

debug = {}
data = {}

debug['almloc'] = 'alamo'
debug['gamsloc'] = 'gams'

# Initialize some dictionaries to store data later
# different keys are used to automate the printing of the .alm later
data['almopts'] = col.OrderedDict.fromkeys(['ninputs', 'noutputs'])
data['almlabs'] = dict.fromkeys(
    ['savexlabels', 'savezlabels', 'xlinks', 'zlinks'])
data['almlstopts'] = {}
data['almset4'] = {}
data['almstropts'] = {}

# potential arguments given to doalamo(**kwargs) are listed here
data['pargs'] = {}
data['pargs']['almopts'] = list(
    ['modeler', 'solvemip', 'linfcns', 'expfcns', 'logfcns', 'sinfcns',
     'cosfcns', 'sampler', 'maxiter', 'tolmaxerror', 'tolesterror', 'sigma',
     'builder', 'linearerror', 'regularizer', 'deltaterm', 'maxterms',
     'convpen', 'constant'])
data['pargs']['almlstopts'] = list(
    ['multi2power', 'multi3power', 'ratiopower', 'monomialpower', 'zisint',
     'xmin', 'xmax'])
# Set4 is exclusively for xmin and xmax (expand to add zmin zmax)
data['pargs']['almset4'] = list(['xmin', 'xmax'])
data['pargs']['almstropts'] = list(
    ['simulator', 'almname', 'tracefname', 'almopt', 'gamssolver'])

# Initial options set here
debug['pargs'] = list(
    ['savescratch', 'savetrace', 'showalm', 'hardset', 'outkeys',
     'expandoutput', 'xval', 'zval','cvfun','almpath','gamspath'])
debug['cvfun'] = False
debug['savescratch'] = False
debug['savetrace'] = False
debug['bignum'] = 100000000
debug['showalm'] = False
debug['temp'] = 0
# expandoutput includes statistics other than the base model
debug['expandoutput'] = False
debug['validation'] = False
# Utilize current hard-set debugging options
debug['hardset'] = False

# Determines if output keys are used in the returned dictionary
debug['outkeys'] = False
data['almstropts']['tracefname'] = 'trace.trc'
data['almstropts']['almname'] = 'temp.alm'
data['almopts']['solvemip'] = 0
data['almopts']['sampler'] = 1
