##############################################################################
# Institute for the Design of Advanced Energy Systems Process Systems
# Engineering Framework (IDAES PSE Framework) Copyright (c) 2018, by the
# software owners: The Regents of the University of California, through
# Lawrence Berkeley National Laboratory,  National Technology & Engineering
# Solutions of Sandia, LLC, Carnegie Mellon University, West Virginia
# University Research Corporation, et al. All rights reserved.
# 
# Please see the files COPYRIGHT.txt and LICENSE.txt for full copyright and
# license information, respectively. Both files are also available online
# at the URL "https://github.com/IDAES/idaes".
##############################################################################
import alamopy
import math
import random
import numpy as np
#Specify number of data poitns in the training and validation sets
ndata=50
nvaldata=1000
random.seed(200)

xdatanp=np.zeros([ndata,2])
zdatanp=np.zeros([ndata,1])
xvaldatanp=np.zeros([nvaldata,2])
zvaldatanp=np.zeros([nvaldata,1])

# Sample training and validation data
for i in range(ndata):
    xdatanp[i][0]=random.uniform(-5,10)
    xdatanp[i][1]=random.uniform(0,15)
    zdatanp[i,0]=1*(xdatanp[i][1]-(5.1/(4*3.14159**2))*xdatanp[i][0]**(2)+(5/3.14159)*xdatanp[i][0]-6)**(2)+10*(1-(1/(8*3.14159))*np.cos(xdatanp[i][0])+10)
for i in range(nvaldata):
    xvaldatanp[i][0]=random.uniform(-5,10)
    xvaldatanp[i][1]=random.uniform(0,15)
    zvaldatanp[i,0]=1*(xvaldatanp[i][1]-(5.1/(4*3.14159**2))*xvaldatanp[i][0]**(2)+(5/3.14159)*xvaldatanp[i][0]-6)**(2)+10*(1-(1/(8*3.14159))*np.cos(xvaldatanp[i][0])+10)

#Alamo is called with a number of options and confidence intervals are produced
res=alamopy.doalamo(xdatanp,zdatanp,xval=xvaldatanp,zval=zvaldatanp,xlabels=('x1','x2'),xmin=(-5,0),xmax=(10,15),monomialpower=(1,2,3,4),expfcns=1,multi2power=(1,2),expandoutput=True,simulator='braninsim.py',maxiter=5,tolmaxerror=50,tolesterror=10,sampler=1,showalm=False,almname='branin')
