##############################################################################
# Institute for the Design of Advanced Energy Systems Process Systems
# Engineering Framework (IDAES PSE Framework) Copyright (c) 2018, by the
# software owners: The Regents of the University of California, through
# Lawrence Berkeley National Laboratory,  National Technology & Engineering
# Solutions of Sandia, LLC, Carnegie Mellon University, West Virginia
# University Research Corporation, et al. All rights reserved.
# 
# Please see the files COPYRIGHT.txt and LICENSE.txt for full copyright and
# license information, respectively. Both files are also available online
# at the URL "https://github.com/IDAES/idaes".
##############################################################################
import alamopy
import math
import random
import numpy as np
ndata=10
nvaldata=1000
rng = 0.001

random.seed(200)
xdatanp=np.zeros([ndata,2])
zdatanp=np.zeros([ndata,1])
inputs = list(['x1','x2'])
#Construct input dictionary                                                                                                                                                       
for i in range(ndata):
    xdatanp[i][0]=random.uniform(-2,2)
    xdatanp[i][1]=random.uniform(-1,1)
    zdatanp[i]=4*xdatanp[i][0]-3*xdatanp[i][1]+2+random.uniform(-rng,rng)

xvaldatanp=np.zeros([nvaldata,2])
zvaldatanp=np.zeros([nvaldata,1])
for i in range(nvaldata):
    xvaldatanp[i][0]=random.uniform(-2,2)
    xvaldatanp[i][1]=random.uniform(-1,1)
    zvaldatanp[i]=4*xvaldatanp[i][0]-3*xvaldatanp[i][1]+2+random.uniform(-rng,rng)

res = alamopy.doalamo(xdatanp, zdatanp, xval=xvaldatanp, zval=zvaldatanp,
                      xlabels=('x1', 'x2'), xmin=(-2, -1), xmax=(2, 1),
                      monomialpower=(1,), showalm=False, simulator='linsim.py',
                      sampler=1, maxiter=5, expandoutput=True)

res = alamopy.almconfidence(res)


