##############################################################################
# Institute for the Design of Advanced Energy Systems Process Systems
# Engineering Framework (IDAES PSE Framework) Copyright (c) 2018, by the
# software owners: The Regents of the University of California, through
# Lawrence Berkeley National Laboratory,  National Technology & Engineering
# Solutions of Sandia, LLC, Carnegie Mellon University, West Virginia
# University Research Corporation, et al. All rights reserved.
# 
# Please see the files COPYRIGHT.txt and LICENSE.txt for full copyright and
# license information, respectively. Both files are also available online
# at the URL "https://github.com/IDAES/idaes".
##############################################################################
import alamopy

#Import additional python modules for creating the synthetic data
import math
import random
import numpy as np

def main():
    # Specify number of poitns to be used in the training set
    # Validation data can be provided optionally
    ndata=50
    random.seed(200)
    xdatanp=np.zeros([ndata,2])
    zdatanp=np.zeros([ndata,1])

    # Sample data and calculate the response
    for i in range(ndata):
        xdatanp[i][0]=random.uniform(-2,2)
        xdatanp[i][1]=random.uniform(-1,1)
        zdatanp[i]=(4-2.1*(xdatanp[i][0]**2)+((xdatanp[i][0]**4)/3))*(xdatanp[i][0]**2)+xdatanp[i][0]*xdatanp[i][1]+(-4+4*(xdatanp[i][1]**2))*(xdatanp[i][1]**2)

    # Call alamo through the alamopy wrapper
    res = alamopy.doalamo(xdatanp,zdatanp,almname='cam6',monomialpower=(1,2,3,4,5,6),multi2power=(1,2))
    print('Model: {}'.format(res['model']))

if __name__ == '__main__':
    main()
